<?php

/**
 * MantisNNTP Plugin
 *
 *
 * Created: 2007-03-13
 * Last update: 2007-03-13
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

define( 'PLUGINS_NNTP_ENABLE_DEFAULT', OFF );
define( 'PLUGINS_NNTP_SERVER_HOST_DEFAULT', '' );
define( 'PLUGINS_NNTP_SERVER_PORT_DEFAULT', '119' );
define( 'PLUGINS_NNTP_SERVER_USERNAME_DEFAULT', '' );
define( 'PLUGINS_NNTP_SERVER_PASSWORD_DEFAULT', '' );
define( 'PLUGINS_NNTP_NEWSGROUP_DEFAULT', 'mantis' );

function plugins_nntp_send( $p_visible_bug_data, $p_message_id, $p_project_id, $p_user_id, $p_header_optional_params = null ) {
    $t_subject = '[' . $p_visible_bug_data['email_project'] . ' ' . bug_format_id( $p_visible_bug_data['email_bug'] ) . ']: ' . $p_visible_bug_data['email_summary'];
    $t_message = lang_get_defaulted( $p_message_id, null );
    if ( is_array( $p_header_optional_params ) ) {
        $t_message = vsprintf( $t_message, $p_header_optional_params );
    }
    if ( ( $t_message !== null ) && ( !is_blank( $t_message ) ) ) {
        $t_message .= " \n";
    }
    $t_message .= email_format_bug_message( $p_visible_bug_data );

    $t_bug_id = $p_visible_bug_data['email_bug'];

    $t_query = "SELECT message_id FROM " . config_get( 'db_table_prefix' ) . "_plugins_nntp_bug_table WHERE bug_id=$t_bug_id";
    $t_result = db_query( $t_query );
    
    $t_post = new PHPMailer();
    $t_post->PluginDir = PHPMAILER_PATH;
    $t_post->SetLanguage( lang_get( 'phpmailer_language', lang_get_current() ), PHPMAILER_PATH . 'language' . DIRECTORY_SEPARATOR );
    $t_post->Mailer = 'smtp';
    $t_post->IsHTML( false );
    $t_post->WordWrap = 80;
    $t_post->Priority = config_get( 'mail_priority' );
    $t_post->CharSet = lang_get( 'charset', lang_get_current() );
    $t_post->From = config_get( 'from_email' );
    $t_post->Sender = config_get( 'return_path_email' );
    $t_post->FromName = '';
    $t_post->Subject = $t_subject;
    $t_post->Body = make_lf_crlf( "\n" . $t_message );
    $t_post->AddCustomHeader( 'Newsgroups: ' . config_get( 'plugins_nntp_newsgroup', PLUGINS_NNTP_NEWSGROUP_DEFAULT, NO_USER, $p_project_id ) );
    $t_references = false;
    if ( db_num_rows( $t_result ) != 0 ) {
        $t_row = db_fetch_array( $t_result );
        $t_post->AddCustomHeader( 'References: ' . $t_row['message_id'] );
        $t_references = true;
    }
    $t_post->SetMessageType();
    $t_header = $t_post->CreateHeader();
    $t_body = $t_post->CreateBody();

    $t_header = explode( "\n", $t_header );
    for( $i=0; $i<count( $t_header ); $i++ ) {
        if ( eregi( 'to: ', $t_header[$i] ) ) {
            unset( $t_header[$i] );
        }
        if ( eregi( 'x-mailer: ', $t_header[$i] ) ) {
            $t_header[$i] .= ' and MantisNNTP ' . MANTIS_NNTP_VERSION;
        }
        if ( eregi( 'message-id: ', $t_header[$i] ) ) {
            $t_message_id = explode( ': ', $t_header[$i] );
            $t_message_id = $t_message_id[1];
        }
    }
    $t_header = implode( "\r\n", $t_header );
    $t_body = str_replace( "\n", "\r\n", $t_body );

    $t_nntp = new NNTP();

    $t_nntp->host = config_get( 'plugins_nntp_server_host', PLUGINS_NNTP_SERVER_HOST_DEFAULT, NO_USER, $p_project_id );
    $t_nntp->port = config_get( 'plugins_nntp_server_port', PLUGINS_NNTP_SERVER_PORT_DEFAULT, NO_USER, $p_project_id );
    $t_nntp->username = config_get( 'plugins_nntp_server_username', PLUGINS_NNTP_SERVER_USERNAME_DEFAULT, NO_USER, $p_project_id );
    $t_nntp->password = config_get( 'plugins_nntp_server_password', PLUGINS_NNTP_SERVER_PASSWORD_DEFAULT, NO_USER, $p_project_id );

    $t_nntp->Connect();
    $t_ok = $t_nntp->Post( $t_header . $t_body );
    $t_nntp->Close();

    if ( $t_ok && !$t_references ) {
        $t_message_id = db_prepare_string( $t_message_id );
        $t_bug_id = db_prepare_int( $t_bug_id );
        $t_query = "INSERT INTO " . config_get( 'db_table_prefix' ) . "_plugins_nntp_bug_table ( bug_id, message_id ) VALUES ( $t_bug_id, '$t_message_id' )";
        db_query( $t_query );
    }
    
    return $t_ok;
}

class NNTP
{

    var $host;
    var $port;
    var $username = '';
    var $password = '';

    var $_socket;
    
    function NNTP() {
        $this->_socket = false;
    }

    function Connect() {
	$this->_socket = fsockopen( $this->host, $this->port );
        if ( $this->_socket ) {
            $t_ans = $this->_ReadResponse();
            if ( substr( $t_ans, 0, 2 ) != "20" ) {
                return false;
            } else {
                fputs( $this->_socket, "mode reader\r\n" );
                $t_ans = $this->_ReadResponse();        
                if ( ( substr( $t_ans, 0, 2 ) != "20" ) ) {
                    return false;
                }
            }
            if ( $this->username != '' ) {
                fputs( $this->_socket, "authinfo user " . $this->username . "\r\n" );
                $t_ans = $this->_ReadResponse();
                fputs( $this->_socket, "authinfo pass " . $this->password . "\r\n" );
                $t_ans = $this->_ReadResponse();
                if ( substr( $t_ans, 0, 3 ) != '281' ) {
                    return false;
                }
            }
            return true;
        }
        return false;
    }

    function Close() {
        if ( $this->_socket ) {
            fputs( $this->_socket, "quit\r\n" );
            $this->_ReadResponse();
            fclose( $this->_socket );
            $this->_socket = false;
        }
    }

    function Post( $p_message ) {
        if ( !$this->_socket ) {
            $this->Connect();
        }
        if ( $this->_socket ) {
            fputs( $this->_socket, "post\r\n" );
            $t_ans = $this->_ReadResponse();
            if ( substr( $t_ans, 0, 3 ) != '340' ) {
                return false;
            }
	    fputs( $this->_socket, $p_message . ".\r\n" );
	    $t_ans = $this->_ReadResponse();
	    if ( substr( $t_ans, 0, 3 ) != '240' ) {
                return false;
            }
	    return true;
        } else {
            return false;
        }
    }

    function _ReadResponse() {
        if ( $this->_socket ) {
            $t_line = fgets( $this->_socket, 1200 );
            $t_line = str_replace( "\n", '', $t_line );
            $t_line = str_replace( "\r", '', $t_line );
            return $t_line;
        }
    }   

}

?>
