<?php

/**
 * MantisNNTP Plugin
 *
 *
 * Created: 2007-03-13
 * Last update: 2007-03-13
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

if ( !ereg( 'plugins_page.php', $_SERVER['REQUEST_URI'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

$t_action = gpc_get_string( 'action', 'none' );
if ( $t_action == 'update' ) {
    $t_project_id = gpc_get_int( 'project_id' );
    $t_enable = gpc_get_bool( 'enable' );
    $t_user_id = gpc_get_int( 'user_id' );
    $t_server_host = gpc_get_string( 'server_host' );
    $t_server_port = gpc_get_int( 'server_port' );
    $t_server_username = gpc_get_string( 'server_username', '' );
    $t_server_password = gpc_get_string( 'server_password', '' );
    $t_newsgroup = gpc_get_string( 'newsgroup' );
    config_set( 'plugins_nntp_enable', $t_enable, NO_USER, $t_project_id );
    config_set( 'plugins_nntp_user_id', $t_user_id, NO_USER, $t_project_id );
    config_set( 'plugins_nntp_server_host', $t_server_host, NO_USER, $t_project_id );
    config_set( 'plugins_nntp_server_port', $t_server_port, NO_USER, $t_project_id );
    config_set( 'plugins_nntp_server_username', $t_server_username, NO_USER, $t_project_id );
    config_set( 'plugins_nntp_server_password', $t_server_password, NO_USER, $t_project_id );
    config_set( 'plugins_nntp_newsgroup', $t_newsgroup, NO_USER, $t_project_id );
    if ( db_is_connected() ) {
        $t_query = "CREATE TABLE IF NOT EXISTS " . config_get( 'db_table_prefix' ) . "_plugins_nntp_bug_table ( bug_id int(7) unsigned not null, message_id varchar(100) not null, primary key( bug_id ) )";
        db_query( $t_query );
    }
    if ( gpc_get_string( 'test', 'false' ) == 'true' ) {
        $t_post = new PHPMailer();
        $t_post->PluginDir = PHPMAILER_PATH;
        $t_post->SetLanguage( lang_get( 'phpmailer_language', lang_get_current() ), PHPMAILER_PATH . 'language' . DIRECTORY_SEPARATOR );
        $t_post->Mailer = 'smtp';
        $t_post->IsHTML( false );
        $t_post->WordWrap = 80;
        $t_post->Priority = config_get( 'mail_priority' );
        $t_post->CharSet = lang_get( 'charset', lang_get_current() );
        $t_post->From = config_get( 'from_email' );
        $t_post->Sender = config_get( 'return_path_email' );
        $t_post->FromName = '';
        $t_post->Subject = 'Testing the MantisNNTP plugin';
        $t_post->Body = make_lf_crlf( "\n" . 'This is a test message.' . "\n\n" . 'Your MantisNNTP plugin configuration is correct.' . "\n" );
        $t_post->AddCustomHeader( 'Newsgroups: ' . $t_newsgroup );
        $t_references = false;
        $t_post->SetMessageType();
        $t_header = $t_post->CreateHeader();
        $t_body = $t_post->CreateBody();

        $t_header = explode( "\n", $t_header );
        for( $i=0; $i<count( $t_header ); $i++ ) {
            if ( eregi( 'to: ', $t_header[$i] ) ) {
                unset( $t_header[$i] );
            }
            if ( eregi( 'x-mailer: ', $t_header[$i] ) ) {
                $t_header[$i] .= ' and MantisNNTP ' . MANTIS_NNTP_VERSION;
            }
        }
        $t_header = implode( "\r\n", $t_header );
        $t_body = str_replace( "\n", "\r\n", $t_body );

        $t_nntp = new NNTP();

        $t_nntp->host = $t_server_host;
        $t_nntp->port = $t_server_port;
        $t_nntp->username = $t_server_username;
        $t_nntp->password = $t_server_password;

        $t_nntp->Connect();
        $t_ok = $t_nntp->Post( $t_header . $t_body );
        $t_nntp->Close();
    }
    header( 'Location: plugins_page.php?plugin=nntp' );
    exit();
}

$t_project_id = helper_get_current_project();

html_page_top1( lang_get( 'plugins_nntp_page_title' ) );
html_page_top2();

?>
  <br />
  <div align="center">
    <?php echo str_replace( '%%project%%', '<b>' . project_get_name( $t_project_id ) . '</b>', lang_get( 'plugins_nntp_configuration_for_project' ) ) ?><br /><br />
    <form name="plugins_nntp" method="post" action="plugins_page.php">
      <input type="hidden" name="action" value="update" />
      <input type="hidden" name="plugin" value="nntp" />
      <input type="hidden" id="test" name="test" value="false" />
      <input type="hidden" name="project_id" value="<?php echo $t_project_id ?>" />
      <table class="width75" cellspacing="1">

        <!-- Server host -->
        <tr <?php echo helper_alternate_class() ?>>
          <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_nntp_enable' ) ?></td>
          <td width="70%">
            <input tabindex="1" type="checkbox" name="enable"<?php check_checked( config_get( 'plugins_nntp_enable', PLUGINS_NNTP_ENABLE_DEFAULT ), ON ) ?>/>
          </td>
        </tr>

        <!-- spacer -->
        <tr>
          <td class="spacer" colspan="2">&nbsp;</td>
        </tr>

        <!-- User -->
        <tr <?php echo helper_alternate_class() ?>>
          <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_nntp_user' ) ?></td>
          <td width="70%">
            <select tabindex="2" name="user_id">
              <?php print_user_option_list( config_get( 'plugins_nntp_user_id', 0 ) ); ?>

            </select>
          </td>
        </tr>

        <!-- spacer -->
        <tr>
          <td class="spacer" colspan="2">&nbsp;</td>
        </tr>

        <!-- Server host -->
        <tr <?php echo helper_alternate_class() ?>>
          <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_nntp_server_host' ) ?></td>
          <td width="70%"><input tabindex="3" type="text" name="server_host" value="<?php echo config_get( 'plugins_nntp_server_host', PLUGINS_NNTP_SERVER_HOST_DEFAULT ); ?>" /></td>
        </tr>

        <!-- Server port -->
        <tr <?php echo helper_alternate_class() ?>>
          <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_nntp_server_port' ) ?></td>
          <td width="70%"><input tabindex="4" type="text" name="server_port" value="<?php echo config_get( 'plugins_nntp_server_port', PLUGINS_NNTP_SERVER_PORT_DEFAULT ); ?>" /></td>
        </tr>

        <!-- Server username -->
        <tr <?php echo helper_alternate_class() ?>>
          <td class="category" width="30%"><?php echo lang_get( 'plugins_nntp_server_username' ) ?></td>
          <td width="70%"><input tabindex="5" type="text" name="server_username" value="<?php echo config_get( 'plugins_nntp_server_username', PLUGINS_NNTP_SERVER_USERNAME_DEFAULT ); ?>" /></td>
        </tr>

        <!-- Server password -->
        <tr <?php echo helper_alternate_class() ?>>
          <td class="category" width="30%"><?php echo lang_get( 'plugins_nntp_server_password' ) ?></td>
          <td width="70%"><input tabindex="6" type="password" name="server_password" value="<?php echo config_get( 'plugins_nntp_server_password', PLUGINS_NNTP_SERVER_PASSWORD_DEFAULT ); ?>" /></td>
        </tr>

        <!-- Newsgroup -->
        <tr <?php echo helper_alternate_class() ?>>
          <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_nntp_newsgroup' ) ?></td>
          <td width="70%"><input tabindex="7" type="text" name="newsgroup" value="<?php echo config_get( 'plugins_nntp_newsgroup', PLUGINS_NNTP_NEWSGROUP_DEFAULT ); ?>" /></td>
        </tr>

        <!-- Submit Button -->
        <tr>
          <td class="left"><span class="required"> * <?php echo lang_get( 'required' ) ?></span></td>
          <td class="center">
            <input tabindex="8" type="submit" class="button" value="<?php echo lang_get( 'submit_button' ) ?>" />&nbsp;
            <input tabindex="9" type="button" class="button" value="<?php echo lang_get( 'plugins_nntp_submit_and_test' ) ?>" onclick="plugins_nntp.test.value='true';plugins_nntp.submit();" />
          </td>
        </tr>

      </table>
    </form>
  </div>

<?php

html_page_bottom1( __FILE__ );

?>
